SystemOrganization addCategory: #'tODE-Core'!

Object subclass: #TOObject
	instanceVariableNames: 'object properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:19'!
actualClass

	^self object class! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
object
	^ object! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
object: anObject
	object := anObject! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
properties

	properties ifNil: [ properties := Dictionary new ].
	^ properties! !

!TOObject methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:47'!
properties: anObject
	properties := anObject! !

TOObject subclass: #TOView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

TOView subclass: #TOObjectFrame
	instanceVariableNames: 'selectedCenterTab centerTabSpec'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOObjectFrame methodsFor: 'private' stamp: 'dkh 5/22/2011 17:50'!
calculateCenterTabSpec
	| currentObject specs groups grouped ids |
	currentObject := self object.
	ids := IdentitySet new.
	specs := (Pragma allNamed: #tODECenterTabSpec from: currentObject class to: nil) reversed 
		collect: [ :pragma | currentObject perform: pragma method selector ].
	specs
		select: [ :each | 
			(ids includes: each id)
				ifTrue: [ false ]
				ifFalse: [ 
					ids add: each id.
					true ] ].
	groups := (specs collect: [ :ea | ea group ]) asSet asSortedCollection: [ :a :b | a < b ].
	grouped := groups
		collect: [ :ea | (specs select: [ :b | b group = ea ]) asSortedCollection: [ :a :b | a order <= b order ] ].
	^ grouped gather: [ :ea | ea ]! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:50'!
centerTabSpec

	centerTabSpec ifNil: [ centerTabSpec := self calculateCenterTabSpec ].
	^centerTabSpec ! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:32'!
label

	^(self object printStringLimitedTo: 50)! !

!TOObjectFrame methodsFor: 'rendering' stamp: 'dkh 5/22/2011 19:02'!
renderFrame: index on: html main: main
	self
		renderLink: [ :s | 
			| frame |
			frame := main currentSpace push: self object.
			frame selectedCenterTab: self selectedCenterTab.
			main updateCenterSideHistory: s ]
		with: [ html strong: index printString , '. ' ]
		on: html.
	index == main historyIndex
		ifTrue: [ html strong: self label ]
		ifFalse: [ html text: self label ]! !

!TOObjectFrame methodsFor: 'rendering' stamp: 'dkh 5/22/2011 11:47'!
renderObjectOn: html renderSelector: renderSelector main: main

	self object
		perform: renderSelector
		withArguments:
			{html.
			self.
			main}! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:39'!
selectedCenterTab

	selectedCenterTab ifNil: [ selectedCenterTab := 0 ].
	^selectedCenterTab ! !

!TOObjectFrame methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:40'!
selectedCenterTab: anIndex

	^selectedCenterTab := anIndex! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:25'!
renderClassHeading: aClass on: html main: main

	self renderSuperclassHeading: aClass on: html main: main.
! !

!TOView methodsFor: 'render links' stamp: 'dkh 5/22/2011 16:53'!
renderLink: block with: labelRenderer on: html

	| id |
	id := html nextId.
	(html anchor)
		url: '#';
		id: id;
		onClick:
			(html jQuery ajax
				script: [ :s | block value: s ]);
		with: labelRenderer! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:46'!
renderSuperclassHeading: aClass on: html main: main
	html text: 'Superclasses: '.
	aClass allSuperclasses reversed
		do: [ :supClass | 
			self
				renderLink: [ :s | 
					| frame |
					frame := main currentSpace push: supClass.
					frame selectedCenterTab: #inspect.
					main updateCenterSideHistory: s ]
				with: [ html strong: supClass name ]
				on: html.
			html text: '->' ].
	self
		renderLink: [ :s | 
			| frame |
			frame := main currentSpace push: aClass.
			frame selectedCenterTab: #inspect.
			main updateCenterSideHistory: s ]
		with: [ html strong: aClass name ]
		on: html! !

Object subclass: #TORoot
	instanceVariableNames: 'currentSpace'
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'tODE-Core'!

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
current

	Current ifNil: [ Current := self new ].
	^Current ! !

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
reset
	"self reset"

	Current := nil! !

!TORoot class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:35'!
singleton

	Singleton ifNil: [ Singleton := self new ].
	^Singleton ! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:40'!
currentFrame

	^self currentSpace currentFrame! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:30'!
currentSpace 

	currentSpace ifNil: [ currentSpace := TOSpace new ].
	^currentSpace ! !

!TORoot methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:42'!
history
	^self currentSpace history! !

Object subclass: #TOSpace
	instanceVariableNames: 'currentFrame history historyIndex inverseFrameMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 18:55'!
currentFrame
	currentFrame
		ifNil: [ 
			currentFrame := self
				push:
					((Dictionary new)
						at: 1 put: 'string';
						at: #symbol put: 2;
						at: 'tODE' put: TORoot current;
						yourself) ].
	^ currentFrame! !

!TOSpace methodsFor: 'private' stamp: 'dkh 5/22/2011 18:58'!
findFrameFor: anObject
	^self inverseFrameMap
		at: anObject
		ifAbsent: [ 
			self inverseFrameMap
				at: anObject
				put:
					(self newFrameFor: anObject) ].
! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 16:57'!
history
	
	history ifNil: [history := OrderedCollection new ].
	^history ! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 17:08'!
historyIndex

	^0! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 18:51'!
inverseFrameMap

	inverseFrameMap ifNil: [ inverseFrameMap := IdentityDictionary new ].
	^inverseFrameMap! !

!TOSpace methodsFor: 'private' stamp: 'dkh 5/22/2011 18:57'!
newFrameFor: anObject
	^ (TOObjectFrame new)
		object: anObject;
		yourself! !

!TOSpace methodsFor: 'accessing' stamp: 'dkh 5/22/2011 19:02'!
push: anObject

	| frame |
	frame := self findFrameFor: anObject.
	self history addLast: frame.
	^currentFrame := frame! !

Object subclass: #TOTabSpec
	instanceVariableNames: 'id label group order priority renderSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Core'!

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:11'!
group
	^ group! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:11'!
group: anObject
	group := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
id
	^ id! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
id: anObject
	id := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
label
	^ label! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:58'!
label: anObject
	label := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:16'!
order
	^ order! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:16'!
order: anObject
	order := anObject! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:00'!
renderSelector
	^ renderSelector! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 09:00'!
renderSelector: anObject
	renderSelector := anObject! !

!TOTabSpec methodsFor: 'rendering' stamp: 'dkh 5/22/2011 11:47'!
renderTabSpecContentOn: html main: main
	main currentFrame renderObjectOn: html renderSelector:self renderSelector main: main
! !

!TOTabSpec methodsFor: 'accessing' stamp: 'dkh 5/22/2011 08:59'!
tabLabel
	
	label ifNil: [ ^self id asString ].
	^label! !

!Collection methodsFor: '*tode-core' stamp: 'dkh 5/22/2011 12:19'!
tODEInspectorFields
	<tODEInspectorFields>
	| i |
	i := 0.
	^ self asArray collect: [ :each | i := i + 1. i -> each ]! !

!Dictionary methodsFor: '*tode-core' stamp: 'dkh 5/22/2011 10:34'!
tODEInspectorFields
	<tODEInspectorFields>
	^ self associations! !
